# $Id: template,v 0.3.2.1 2002/09/12 11:00:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_OPENSSH))
PACKAGES += OPENSSH
endif

#
# Paths and names 
#
OPENSSH			= openssh-3.5p1
OPENSSH_URL 		= ftp://ftp.openssh.org/foo/bar/$(OPENSSH).tar.gz
OPENSSH_SOURCE		= $(SRCDIR)/$(OPENSSH).tar.gz
OPENSSH_DIR 		= $(BUILDDIR)/$(OPENSSH)
OPENSSH_EXTRACT		= gzip -dc

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

OPENSSH_get: $(STATEDIR)/OPENSSH.get

$(STATEDIR)/OPENSSH.get: $(OPENSSH_SOURCE)
	touch $@

$(OPENSSH_SOURCE):
	@echo
	@echo --------
	@echo OPENSSH.get
	@echo --------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(OPENSSH_URL)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

OPENSSH_extract: $(STATEDIR)/OPENSSH.extract

$(STATEDIR)/OPENSSH.extract: $(STATEDIR)/OPENSSH.get
	@echo
	@echo ------------
	@echo OPENSSH.extract
	@echo ------------
	@echo
	$(OPENSSH_EXTRACT) $(OPENSSH_SOURCE) | $(TAR) -C $(BUILDDIR) -xf -
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

OPENSSH_prepare: $(STATEDIR)/OPENSSH.prepare

OPENSSH_AUTOCONF =  --prefix=$(PTXCONF_PREFIX) --with-ipv4-default 
OPENSSH_AUTOCONF += --without-pam --without-shadow --without-md5-passwords 
OPENSSH_AUTOCONF += --with-zlib=$(PTXCONF_PREFIX)
# TODO dont know if this finds its way hardcoded into some binary:
OPENSSH_AUTOCONF += --with-privsep-path=$(PTXCONF_PREFIX)/var/empty

$(STATEDIR)/OPENSSH.prepare: $(STATEDIR)/OPENSSH.extract $(STATEDIR)/OPENSSL.install
	@echo
	@echo ------------
	@echo OPENSSH.prepare
	@echo ------------
	@echo
	cd $(OPENSSH_DIR) && LIBS=-lcrypt ./configure $(OPENSSH_AUTOCONF)
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

OPENSSH_compile: $(STATEDIR)/OPENSSH.compile

$(STATEDIR)/OPENSSH.compile: $(STATEDIR)/OPENSSH.prepare 
	@echo
	@echo ----------------------- 
	@echo OPENSSH.compile
	@echo -----------------------
	@echo
	cd $(OPENSSH_DIR) && PATH=$(PTXCONF_PREFIX)/bin:$$PATH make
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

OPENSSH_install: $(STATEDIR)/OPENSSH.install

$(STATEDIR)/OPENSSH.install: $(STATEDIR)/OPENSSH.compile
	@echo
	@echo ----------------------- 
	@echo OPENSSH.install
	@echo -----------------------
	@echo
	PATH=$(PTXCONF_PREFIX)/bin:$$PATH make -C $(OPENSSH_DIR) install PREFIX=$(PTXCONF_PREFIX)
	touch $@

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

OPENSSH_targetinstall: $(STATEDIR)/OPENSSH.targetinstall

$(STATEDIR)/OPENSSH.targetinstall: $(STATEDIR)/OPENSSH.install
	@echo
	@echo ------------------ 
	@echo OPENSSH.targetinstall
	@echo ------------------
	@echo
	echo 'TODO: install openssh files (dont forget privsep)' && exit 1
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

OPENSSH_clean: 
	rm -rf $(STATEDIR)/OPENSSH.* $(OPENSSH_DIR)

# vim: syntax=make
